/*
   Esta api es software libre con licencia GPLv2 o superior.
   Creada por Haylem Candelario Bauza.
   Probada sobre debian 9 stretch.
*/

#include "prototipos.h"
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <stdio.h>

#ifndef HAYLEMAPI_H
#define HAYLEMAPI_H

int contador = 0, indicio = 0;
int cambiacuenta = 0;
int hayint = NOHAYINTERNET;

void asociaranclawifi(const char *interfacered, const char *ssid, const char *bssid)
{
   char cmd[250] = {'\0'};
   strcpy(cmd, "iw dev ");
   strcat(cmd, interfacered);
   strcat(cmd, " connect ");
   strcat(cmd, ssid);
   strcat(cmd, " ");
   strcat(cmd, bssid);
   strcpy(_bssid, bssid);
   desasociarawifi(interfacered);
   system(cmd);
}

void asociarawifiauto(const char *interfacered, const char *ssid)
{
   char cmd[250] = {'\0'};
   strcpy(cmd, "iw dev ");
   strcat(cmd, interfacered);
   strcat(cmd, " connect ");
   strcat(cmd, ssid);
   strcpy(_ssid, ssid);
   strcpy(_bssid, "auto"); /* Que se muestre auto en la info */
   desasociarawifi(interfacered);
   system(cmd);
}

void sincronizardiscos(void)
{
   system("sync");
}


void ponermascarared(const char *interfacered, const char *mascara)
{
   char cmd[250] = {'\0'};
   strcpy(cmd, "ifconfig ");
   strcat(cmd, interfacered);
   strcat(cmd, " netmask ");
   strcat(cmd, mascara);
   system(cmd);
}

const char *obtenerbssidactual(const char *interfacered)
{
  char cmd[250];
  char b[800] = {'\0'};
  char bcad[800] = {'\0'};
  FILE *f = NULL;
  int i = 0;
  char bssid[80] = {'\0'};


  strcpy(cmd, "iw dev ");
  strcat(cmd, interfacered);
  strcat(cmd, " link");

	
  f = popen(cmd, "r");
	
  if(f == NULL)
   {
      printf("\n\nNo existe iw, saliendo...\n\n");
      return NOBSSIDLOCAL;
   }
 
   while(!feof(f))
   {
     b[i] = fgetc(f);
     if(b[i] == EOF)
     {
       b[i] = '\0';
       break;
     }
     else
     {
       if(i >= 799)
       {
         pclose(f);
         return NOBSSIDLOCAL;
       }

       ++i;
     }
   }

  pclose(f);
  
  if(strcmp(b, "") == 0)
     return NOBSSIDLOCAL;
  
  if(estaasociado(interfacered) != ESTAASOCIADO) 
     return NOBSSIDLOCAL; 

     strcpy(bssid, strstr(b, "to"));
     if(strlen(bssid) < 2)
        return NOBSSIDLOCAL;

     strcpy(bssid, strtok(bssid, " "));
     strcpy(bssid, strtok(NULL, " "));
     strcpy(bssid, strtok(bssid, "\n"));
     return strdup(bssid);
}

void file_save_data(const char *filename, const char *data)
{
   FILE *f = NULL;
   f = fopen(filename, "a");
   if(f == NULL)
   {
      puts("No se puede crear el archivo para save data");
      return;
   }

   fputs(data, f);
   fprintf(f, "\n");
   fclose(f);
}

void * sys_copy_file(const char *orig, const char *dest)
{
  FILE *fl = NULL;
  char cmd[1000] = {'\0'};

  strcpy(cmd, "cp -fv ");
  strcat(cmd, orig);
  strcat(cmd, " ");
  strcat(cmd, dest);

  fl = popen(cmd, "r");

  if(fl == NULL)
     return NULL;

	while(!feof(fl))
	{
		fgetc (fl);
	}
		
   pclose(fl);
}

void sys_disable_ipv6(void)
{
 system("sysctl net.ipv6.conf.all.disable_ipv6=1");
}

void sys_enable_ipv6(void)
{
 system("sysctl net.ipv6.conf.all.disable_ipv6=0");
}

void sys_wifi_set_country(const char *country)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "iw reg set ");
  strcat(cmd, country);
  printf("Nacionalidad puesta en %s\n", country);
  system(cmd);
}


void sys_tcp_low_latency(void)
{
   system("sysctl net.ipv4.tcp_low_latency=1");
}

void sys_tcp_high_latency(void)
{
   system("sysctl net.ipv4.tcp_low_latency=0");
}

void limpiapantalla(void)
{
   system(CLS);
}

/* Solo usada internamente por generartraficored */
void * checkinternet(void *x)
{
   if(contador >= MAXCONT)
   {
         fprintf(stdout, "Cambiando cuenta...\n");
         cambiacuenta = 1; /* Cambiar cuenta. */
         contador = 0;
         return NULL;
   }

   if((contador == 100) || (contador == 150) || (contador == 180) || (contador == 190))
   {
       desasociarawifi(_interface);
       puts(_ip);
       puts(_gw);
       defineip(_interface, _ip);
       definepasarela(_interface, _gw);
   }
   
   
   matarproceso("ping");
   hayint = verificainternet("google.com"); 

   if(hayint == HAYINTERNET)
   {
     contador = 0;
     indicio = 1;
   }



}

void generartraficored(const char *interfacered, const char *essid, unsigned short int modo)
{

   /*char bssidact[20] = {'\0'};*/

   /* Ver si esta asociado y si no asociarse a la wifi */

   strcpy(_interface, interfacered);
   cambiacuenta = 0;
   contador = 0;
   indicio = 0;

  while(cambiacuenta != 1)
  {

   if(modo == TRAFICOCONSSID)
   {

      if(estaasociado(interfacered) == NOESTAASOCIADO)
      {
         limpiapantalla();
         puts("!!!DESASOCIADO...");
         puts(_ip);
         puts(_gw);
         activatarjetared(interfacered);
         defineip(interfacered, _ip);
         definepasarela(interfacered, _gw);
         if(contador >= MAXCONT)
         {
            contador = 0;
            indicio = 0;
            cambiacuenta = 1;
            return;
         }

         /*strcpy(bssidact, obtenerbssidactual(interfacered));*/
         printf("DESASOCIADO, REASOCIANDO... CONTADOR: %d BSSID %s\n ", contador, _bssid);
         /*printf("ANCLADO: [%s]\n", bssidact);*/
         if(strcmp(_bssid, "auto") == 0)
            asociarawifiauto(interfacered, essid);
         else
            asociaranclawifi(interfacered, essid, _bssid);

         ++contador;
      }
      else
      {

         if(contador >= MAXCONT)
         {
            contador = 0;
            cambiacuenta = 1;
            return;
         }

         /* Trafico general */
         /* Hay internet? */
         ++contador;
         ejecutahilofuncindepend(checkinternet);
         limpiapantalla();
         printf("CONTADOR: %d BSSID:%s ESSID:%s\n", contador, _bssid, essid);

      }

    }
         if(indicio == 0 && contador > 20)
         {
            contador = 0;
            matarproceso("ping");
            return;
         }

         retardoenseg(2);
         matarproceso("ping");

  } /* Fin de while */

}

void ejecutahilofuncjoined(void *(*func) (void *))
{
  static pthread_t hilo;
  int ret = 0;

  memset(&hilo, 0, sizeof(pthread_t));
  pthread_create(&hilo, NULL, func, NULL);

  if(ret != 0)
     pthread_cancel(hilo);

  pthread_join(hilo, NULL);
}

void ejecutahilofuncindepend(void *(*func) (void *))
{
  pthread_t hilo;
  int ret = 0;

  memset(&hilo, 0, sizeof(pthread_t));
  ret = pthread_create(&hilo, NULL, func, NULL); 
  if(ret != 0)
     pthread_cancel(hilo);

}

void ejecutardespuesdeseg(void *proceso, unsigned long int seg)
{
  pthread_t hilo;
  int ret = 0;
  void* fndespseg(void *orden);

  _seg = seg;

  memset(&hilo, 0, sizeof(pthread_t));
  ret = pthread_create(&hilo, NULL, fndespseg, proceso); 
  if(ret != 0)
     pthread_cancel(hilo);


}

/* Solo usada por el hilo limitador de tiempo */
void* functime(void *orden)
{
   system(orden);
}

void* fndespseg(void *orden)
{
   retardoenseg(_seg);
   system(orden);
   puts("[SNIFFER MATADO TIEMPO DE ESPERA EXPIRADO]");
}

void restaurarterminal(void)
{
 system("reset");
}

void killallproceso(const char *proceso)
{
  char cmd[200] = {'\0'};
  strcpy(cmd, "killall -9 ");
  strcat(cmd, proceso);
  system(cmd);
  /* Restaura terminal */
  restaurarterminal();
}

void ejecutaprochilotiempo(void *orden , unsigned long int tiempo)
{
  pthread_t hilo;
  char *cmd = NULL;
  cmd = (char *) orden;
  pthread_create(&hilo, NULL, functime, orden); 
  retardoenseg(tiempo);
  killallproceso(orden);

}

const char * cargararchivo(const char *carpeta, const char *nombrearchivo)
{
  static char bufer[9000000] = {'\0'};
  char ruta[200] = {'\0'};
  int pos = 0;
	
  FILE *archv = NULL;

  strcpy(ruta, carpeta);
  strcat(ruta, "/");	
  strcat(ruta, nombrearchivo);	

  archv = fopen(ruta, "r");

  if(archv == NULL)
  {
    printf("No se puede abrir el archivo %s para leer\n", ruta);
	return ARCHIVONOCARGADO;
  }

  while(!feof(archv))
  {
     bufer[pos] = fgetc(archv);
	 if(bufer[pos] == EOF)
		  break;
     if(pos >= 888889)
		  break;
	  
	 ++pos;
  }
  bufer[pos] = '\0';
  fclose(archv);
  return bufer;
}


void sys_pkill(const char *process)
{

   char cmd[250] = {'\0'};
   strcpy(cmd, "pkill ");
   strcat(cmd, process);
   system(cmd);
}

void agregardns(const char *rutaresolvconf , const char *dns)
{
   FILE *f = NULL;

   f = fopen(rutaresolvconf, "a");
   if(f == NULL) 
   {
       printf("No se pudo escribir en %s.\n", rutaresolvconf);
      return;
   }

   fprintf(f, "nameserver %s\n", dns);
   fclose(f);
  
}

void vaciarchivo(const char *rutarchivo)
{
   FILE *f = NULL;

   f = fopen(rutarchivo, "w");
   if(f == NULL) 
   {
       printf("No se pudo escribir en %s.\n", rutarchivo);
      return;
   }
   fclose(f);
}

void limpiadnsfile(const char *rutaresolvconf)
{
   vaciarchivo(rutaresolvconf);
}

void creararchivovacio(const char *rutaresolvconf)
{
   vaciarchivo(rutaresolvconf);
}

void desasociarawifi(const char *interfacered)
{
    char cmd[80] = {'\0'};
    strcpy(cmd, "iw dev ");
    strcat(cmd, interfacered);
    strcat(cmd, " disconnect ");
    system(cmd);
}

void asociarawifi(const char *interfacered, const char *essid)
{
    char cmd[80] = {'\0'};
    strcpy(cmd, "iw dev ");
    strcat(cmd, interfacered);
    strcat(cmd, " connect ");
    strcat(cmd, essid);
    strcpy(_ssid, essid);
    system(cmd);
}

const char **obtenerdnslist(void)
{
  char cmd[80] = {'\0'};
  FILE *f = NULL;
  static const char *lst[100];
  int k = 0, i = 0;
  char buf[2000] = {'\0'};

  strcpy(cmd, "cat /etc/resolv.conf |grep -v search|grep -v \"#\"|cut -d\" \" -f2");

  f = popen(cmd, "r");

  if(f == NULL)
   return NULL;

  while(!feof(f))
  {
    buf[k] = fgetc(f);
    if(buf[k] == EOF) { buf[k] = '\0'; buf[k - 1] = '\0' /* Quia linea blanco */; break; }

   ++k;
  }

  pclose(f);

  puts("=== DNS archivo local ===");
  puts(buf);
  puts("===== DNS a bufer =======");

  lst[i] = strtok(buf, "\n");  
  while(lst[i] != NULL)
  {
    lst[++i] = strtok(NULL, "\n");
  }

 return lst;

}


void startnmanager(void)
{
    char cmd[80] = {'\0'};
    strcpy(cmd, "systemctl start network-manager");
    system(cmd);
    strcpy(cmd, "service network-manager start");
    system(cmd);
    strcpy(cmd, "/etc/init.d/network-manager start");
    system(cmd);
}

void stopnmanager(void)
{
    char cmd[80] = {'\0'};
    strcpy(cmd, "systemctl stop network-manager");
    system(cmd);
    strcpy(cmd, "service network-manager stop");
    system(cmd);
    strcpy(cmd, "/etc/init.d/network-manager stop");
    system(cmd);
}

void defineip(const char *interfacered, const char *ip)
{
    char cmd[80] = {'\0'};
    liberaiplocal(interfacered);
    strcpy(cmd, "ip address change scope global ");
    strcat(cmd, ip);
    strcat(cmd, "/255.0.0.0 dev ");
    strcat(cmd, interfacered);
    strcpy(_ip, ip);
    system(cmd);
}

void ifconfig_definemtu(const char *interfacered, const char *mtu)
{
    char cmd[80] = {'\0'};

    strcpy(cmd, "ifconfig ");
    strcat(cmd, interfacered);
    strcat(cmd, " mtu ");
    strcat(cmd, mtu);
    system(cmd);
}

void definemtu(const char *interfacered, const char *mtu)
{
    char cmd[80] = {'\0'};

    strcpy(cmd, "ip link set dev ");
    strcat(cmd, interfacered);
    strcat(cmd, " mtu ");
    strcat(cmd, mtu);
    system(cmd);
}

void definepasarela(const char *interfacered, const char *pasarela)
{
    char cmd[80] = {'\0'};

    strcpy(cmd, "ip route del default via ");
    strcat(cmd, pasarela);
    strcat(cmd, " dev ");
    strcat(cmd, interfacered);
    system(cmd);

    strcpy(cmd, "ip route add default via ");
    strcat(cmd, pasarela);
    strcat(cmd, " dev ");
    strcat(cmd, interfacered);
    system(cmd);

    strcpy(cmd, "route add default gw ");
    strcat(cmd, pasarela);
    strcat(cmd, " dev ");
    strcat(cmd, interfacered);

    strcpy(_gw, pasarela);

    system(cmd);
}

void definemac(const char *interfacered, const char *mac)
{
    char cmd[80] = {'\0'};

    strcpy(cmd, "ip link set dev ");
    strcat(cmd, interfacered);
    strcat(cmd, " address ");
    strcat(cmd, mac);

    desactivatarjetared(interfacered);
    system(cmd);
    activatarjetared(interfacered);
}

void definetxpowerwifi(const char *interfacered, const char *potencia)
{
    char cmd[80] = {'\0'};

    strcpy(cmd, "iw ");
    strcat(cmd, interfacered);
    strcat(cmd, " set txpower fixed ");
    strcat(cmd, potencia);	
    printf("Definiendo txpower via iw en %s = %s\n", interfacered, potencia); 
    system(cmd);
}

void iwconfig_fijafrag(const char *interfacered, const char *frag)
{
    char cmd[80] = {'\0'};

    /* Poner frag */
    strcpy(cmd, "iwconfig ");
    strcat(cmd, interfacered);
    strcat(cmd, " frag ");
    strcat(cmd, frag);	
    printf("Definiendo FRAG via iwconfig en %s = %s\n", interfacered, frag); 
    system(cmd);
}

void iwconfig_fijarts(const char *interfacered, const char *rts)
{
    char cmd[80] = {'\0'};

    /* Poner rts */
    strcpy(cmd, "iwconfig ");
    strcat(cmd, interfacered);
    strcat(cmd, " rts ");
    strcat(cmd, rts);	
    printf("Definiendo RTS via iwconfig en %s = %s\n", interfacered, rts); 
    system(cmd);
}

void iwconfig_fijarbssidap(const char *interfacered, const char *bssid)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "iwconfig ");
  strcat(cmd,  interfacered);
  strcat(cmd, " ap ");
  strcat(cmd, bssid);
  printf("Anclando  iwconfig a %s\n", bssid);
  strcpy(_bssid, bssid);
  system(cmd);
}

void nopowersavewifi(const char *interfacered)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "iw ");
  strcat(cmd, interfacered);
  strcat(cmd, " set power_save off ");

  printf("Desabilitando power save\n");
  system(cmd);
}

void liberaiplocal(const char *interfacered)
{
    char cmd[80] = {'\0'};
    FILE *f = NULL;

    strcpy(cmd, "ip address flush dev ");
    strcat(cmd, interfacered);
    strcat(cmd, " scope global");

    f = popen(cmd, "r");
    if(f != NULL)
    {
     printf("Liberando IP en %s\n", interfacered); 
    }

   pclose(f);

}

unsigned short int tcpdumpcaptrafport(const char *interfacered, const char *rangored, const char *puertocap, const char *pasarela)
{ 
   char cmd[800] = {'\0'};
   char *args[26];
   char b[20000] = {'\0'};
   int i = 0;
   FILE *f = NULL;
   FILE *fout = NULL;
   

   matarproceso("tcpdump");
   strcpy(cmd, "tcpdump --immediate-mode ");
   strcat(cmd, " -I");
   strcat(cmd, " -i ");
   strcat(cmd, interfacered);
   strcat(cmd, " -n -c 1 -l -eq dst net ");
   strcat(cmd, rangored);
   strcat(cmd, " and port ");
   strcat(cmd, puertocap);
   strcat(cmd, " and tcp and not host ");
   strcat(cmd, pasarela);

   f = popen(cmd, "r");
	
   if(f == NULL)
   {
      printf("\n\nNo existe tcpdump, saliendo...\n\n");
      return ERRORCAPTURA;
   }
   puts("CAPTURANDO DATOS DE SNIFFER...");

   while(!feof(f))
   {
       b[i] = fgetc(f);

       if(b[i] == EOF)
         break;
       else
       {
         if(i >= 1999)
            break;
       }
       
       ++i;
   }

   b[i] = '\0';

  pclose(f);

  puts(b);
  fout = fopen("/tmp/captrout", "w");
	
  if(fout == NULL)
  {
      printf("\n\nNo se pudo guardar la captura...\n\n");
      return ERRORCAPTURA;
  }
  fputs(b, fout);
  fclose(fout);

}

const char *obtienebssidvictimacap(const char *carpetacap, const char *archivocapt)
{
   const char *contenido = NULL;
   contenido = cargararchivo(carpetacap, archivocapt);
   char *parte = NULL;
   char *tokens[6];
   char bssid[100] = {'\0'};

     parte = strstr(contenido, "BSSID");

     if(parte == NULL)
     {
       puts("NO SE DETECTO BSSID VICTIMA");
       return NOBSSIDVICTIMA;
     }
     else
     {
        parte = strstr(parte, ":");
        parte = strtok(parte, ":");
        tokens[0] = parte;
        parte = strtok(NULL, ":");
        tokens[1] = parte;
        parte = strtok(NULL, ":");
        tokens[2] = parte;
        parte = strtok(NULL, ":");
        tokens[3] = parte;
        parte = strtok(NULL, ":");
        tokens[4] = parte;
        parte = strtok(NULL, ":");
        tokens[5] = parte;
  
        strcpy(bssid, tokens[0]);
        strcat(bssid, ":");
        strcat(bssid, tokens[1]);
        strcat(bssid, ":");
        strcat(bssid, tokens[2]);
        strcat(bssid, ":");
        strcat(bssid, tokens[3]);
        strcat(bssid, ":");
        strcat(bssid, tokens[4]);
        strcat(bssid, ":");
        strcat(bssid, tokens[5]);
        strcpy(bssid, strtok(bssid, " "));

        printf("BSSID DETECTADO EN ARCHIVO %s\n", bssid);
     }

     return strdup(bssid);
}


const char *obtienemacfuentecap(const char *carpetacap, const char *archivocapt)
{
   const char *contenido = NULL;
   contenido = cargararchivo(carpetacap, archivocapt);
   char *parte = NULL;
   char *tokens[6];
   char mac[100] = {'\0'};

     parte = strstr(contenido, "SA");

     if(parte == NULL)
     {
       puts("NO SE DETECTO NINGUNA MAC");
       return NOMACFUENTE;
     }
     else
     {
        parte = strstr(parte, ":");
        parte = strtok(parte, ":");
        tokens[0] = parte;
        parte = strtok(NULL, ":");
        tokens[1] = parte;
        parte = strtok(NULL, ":");
        tokens[2] = parte;
        parte = strtok(NULL, ":");
        tokens[3] = parte;
        parte = strtok(NULL, ":");
        tokens[4] = parte;
        parte = strtok(NULL, ":");
        tokens[5] = parte;
  
        strcpy(mac, tokens[0]);
        strcat(mac, ":");
        strcat(mac, tokens[1]);
        strcat(mac, ":");
        strcat(mac, tokens[2]);
        strcat(mac, ":");
        strcat(mac, tokens[3]);
        strcat(mac, ":");
        strcat(mac, tokens[4]);
        strcat(mac, ":");
        strcat(mac, tokens[5]);
        strcpy(mac, strtok(mac, " "));

        printf("MAC DE ROUTER FUENTE DETECTADA EN ARCHIVO %s\n", mac);
     }

     return strdup(mac);
}

const char *obtienemacvictimacap(const char *carpetacap, const char *archivocapt)
{
   const char *contenido = NULL;
   char *parte = NULL;
   char *tokens[6];
   char mac[800] = {'\0'};

   contenido = (char *) malloc(sizeof(char ) * 1000);
   parte = (char *) malloc(sizeof(char ) * 1000);

   contenido = cargararchivo(carpetacap, archivocapt);
   if((contenido == NULL) || (strcmp(contenido, "") == 0) || (strcmp(contenido, " ") == 0) || (strlen(contenido) <= 0))
      return NOMACVICTIMA;

     parte = strstr(contenido, "DA");

     if(parte == NULL)
     {
       puts("NO SE DETECTO NINGUNA MAC");
       return NOMACVICTIMA;
     }
     else
     {
        parte = strstr(parte, ":");
        parte = strtok(parte, ":");
        tokens[0] = parte;
        parte = strtok(NULL, ":");
        tokens[1] = parte;
        parte = strtok(NULL, ":");
        tokens[2] = parte;
        parte = strtok(NULL, ":");
        tokens[3] = parte;
        parte = strtok(NULL, ":");
        tokens[4] = parte;
        parte = strtok(NULL, ":");
        tokens[5] = parte;
  
        strcpy(mac, tokens[0]);
        strcat(mac, ":");
        strcat(mac, tokens[1]);
        strcat(mac, ":");
        strcat(mac, tokens[2]);
        strcat(mac, ":");
        strcat(mac, tokens[3]);
        strcat(mac, ":");
        strcat(mac, tokens[4]);
        strcat(mac, ":");
        strcat(mac, tokens[5]);
        strcpy(mac, strtok(mac, " "));

        printf("MAC DETECTADA EN ARCHIVO %s\n", mac);
     }

     return strdup(mac);
}

const char *obtieneipvictimacap(const char *carpetacap, const char *archivocapt)
{
   const char *contenido = NULL;
   char *parte = NULL;
   char *tokens[4];
   char ip[100] = {'\0'};

   contenido = cargararchivo(carpetacap, archivocapt);
   if((contenido == NULL) || (strcmp(contenido, "") == 0) || (strcmp(contenido, " ") == 0) || (strlen(contenido) <= 0))
      return NOIPVICTIMA;

     parte = (char *) malloc(sizeof(char) * 1000);
     strcpy(parte, strstr(contenido, ">"));

     if(parte == NULL)
     {
       puts("NO SE DETECTO NINGUNA IP");
       return NOIPVICTIMA;
     }
     else
     {
        parte = strstr(parte, " ");
        parte = strtok(parte, ".");
        tokens[0] = parte;
        parte = strtok(NULL, ".");
        tokens[1] = parte;
        parte = strtok(NULL, ".");
        tokens[2] = parte;
        parte = strtok(NULL, ".");
        tokens[3] = parte;
      
        strcpy(ip, tokens[0]);
        strcat(ip, ".");
        strcat(ip, tokens[1]);
        strcat(ip, ".");
        strcat(ip, tokens[2]);
        strcat(ip, ".");
        strcat(ip, tokens[3]);


        printf("IP DETECTADA EN ARCHIVO %s\n", ip);
     }

     return strdup(ip);
}

void activatarjetared(const char *interfacered)
{
 char cmd[250] = {'\0'};
 
 printf("Activando tarjeta de red %s\n", interfacered); 
 strcpy(cmd, "ifconfig ");
 strcat(cmd, interfacered);
 strcat(cmd, " up");
 system(cmd);

 printf("Activando tarjeta de red %s\n", interfacered); 
 strcpy(cmd, "ip link set ");
 strcat(cmd, interfacered);
 strcat(cmd, " up");
 system(cmd);
 retardoenseg(1);
}

void desactivatarjetared(const char *interfacered)
{
 char cmd[80] = {'\0'};
 
 printf("Desactivando tarjeta de red %s\n", interfacered); 
 strcpy(cmd, "ifconfig ");
 strcat(cmd, interfacered);
 strcat(cmd, " down");
 system(cmd);

 strcpy(cmd, "ip link set ");
 strcat(cmd, interfacered);
 strcat(cmd, " down");
 system(cmd);
 retardoenseg(1);
}

void wifimonitoroff(const char *interfacered)
{
   desactivatarjetared(interfacered);
   ponermodowifimanaged(interfacered);
   activatarjetared(interfacered);
}

void ponermodowifimanaged(const char *interfacered)
{
   char cmd[250] = {'\0'};

   strcpy(cmd, "iw ");
   strcat(cmd, interfacered);
   strcat(cmd, " set type managed");
   puts("Cambiando modo de tarjeta de red con iw...");
   system(cmd);

   strcpy(cmd, "iwconfig ");
   strcat(cmd, interfacered);
   strcat(cmd, " mode Managed");
   puts("Cambiando modo de tarjeta de red con iwconfig...");
   system(cmd);


}


void exectimeout(char *args[] , unsigned long int seg)
{
 pid_t pid;
 pid = fork();
 if(pid == -1)
 {
    perror("Error creando proceso fork");
    return;
 }

 if(pid == 0)
 {
    execvp((const char *)args[0], args);
 }
 else
 {
   retardoenseg(seg);
   kill(pid, SIGKILL);
   wait(NULL);
   fprintf(stdout, "Proceso terminado\n");
 }
}

unsigned short int tarjetaredapagada(const char *interfacered)
{
  char cmd[250];
  char b[80] = {'\0'};
  FILE *f = NULL;
  int i = 0;

  strcpy(cmd, "ip link show dev ");
  strcat(cmd, interfacered);

	
  f = popen(cmd, "r");
	
  if(f == NULL)
   {
      printf("\n\nNo existe ip link, saliendo...\n\n");
      return 1;
   }
   puts("VERIFICANDO ESTADO ACTIVO DE INTERFACE...");
 
   while(!feof(f))
   {
     b[i] = fgetc(f);
     if(b[i] == EOF)
     {
       b[i] = '\0';
     }
     else
     {
       if(i >= 240)
          b[i] = '\0';

       ++i;
     }
   }

  pclose(f);
  
  if(strcmp(b, "") == 0)
     return TARJETAREDAPAGADA;

  if(strstr(b, "state DOWN") != NULL)
    return TARJETAREDAPAGADA;
  else
    return TARJETAREDENCENDIDA;
}

void defretrylim(const char *interfacered, const char *retry)
{
  char cmd[80] = {'\0'};

  strcpy(cmd, "iwconfig ");
  strcat(cmd, interfacered);
  strcat(cmd, " retry ");
  strcat(cmd, retry);
  printf("Poniendo retry limit a %s\n", retry);
  system(cmd);
}

void defineratewifi(const char *interfacered, const char *rate)
{
  char cmd[80] = {'\0'};

  strcpy(cmd, "iw ");
  strcat(cmd, interfacered);
  strcat(cmd, " set bitrates legacy-2.4 ");
  strcat(cmd, rate);
  printf("Poniendo bit rate  a %s via iw\n", rate);

  strcpy(cmd, "iwconfig ");
  strcat(cmd, interfacered);
  strcat(cmd, " rate ");
  strcat(cmd, rate);
  printf("Poniendo bit rate  a %s via iwconfig\n", rate);
  system(cmd);


  system(cmd);
}

void pingcompleto(const char *host, unsigned short int flood)
{
  char cmd[80] = {'\0'};

 if(flood == 1)
    {
	   strcpy(cmd, "ping -f ");
    }
 else
	{
	   strcpy(cmd, "ping ");	
	}
	strcat(cmd, host);
	system(cmd);
}

void anclarcanalwifi(const char *interfacered, const char *canal)
{
  char cmd[80] = {'\0'};

  strcpy(cmd, "iw ");
  strcat(cmd, interfacered);
  strcat(cmd, " set channel ");
  strcat(cmd, canal);
  printf("Poniendo canal %s via iw\n", canal);
  system(cmd);
}


void retardoenseg(unsigned long int seg)
{
  sleep(seg);
}

const char *estaasociado(const char *interfacered)
{
   char cmd[80] = {'\0'}, bufer[512] = {'\0'};
   int i = 0;
   FILE *tub = NULL;

   if(interfacered == NOESTAASOCIADO) return NOESTAASOCIADO;
   strcpy(cmd, "iw dev ");
   strcat(cmd, interfacered);
   strcat(cmd, " info");

   tub = popen(cmd, "r");
   if(tub == NULL) return NOESTAASOCIADO;

   while(!feof(tub))
   {
    bufer[i] = fgetc(tub);
    if(i >= 511) return NOESTAASOCIADO;
    if(bufer[i] == '\0') return NOESTAASOCIADO;
    if(bufer[i] == EOF) bufer[i] = '\0';
    ++i;
   }
   pclose(tub);

   if(strstr(bufer, "ssid") == 0)
      return NOESTAASOCIADO;
   else
      return ESTAASOCIADO;

}

const char *obtenerpasarela(const char *interfacered)
{
   char cmd[80] = {'\0'}, bufer[1000] = {'\0'}, gw[80] = {'\0'};
   int i = 0;
   FILE *tub = NULL;

   if(interfacered == NOHAYPASARELA) return NOHAYPASARELA;
   strcpy(cmd, "ip route show dev ");
   strcat(cmd, interfacered);

   tub = popen(cmd, "r");
   if(tub == NULL) return NOHAYPASARELA;

   while(!feof(tub))
   {
    bufer[i] = fgetc(tub);
    if(i >= 999) return NOHAYPASARELA;
    if(bufer[i] == '\0') return NOHAYPASARELA;
    if(bufer[i] == EOF)
    {
       bufer[i] = '\0';
       break;
    }

    ++i;
   }
   pclose(tub);

  if(strcmp(bufer, "") == 0) return NOHAYPASARELA;
  if(strcpy(gw, strstr(bufer, "via")) != NULL)
     {
        strcpy(gw, strstr(gw, " "));
        strcpy(gw, strtok(gw, " "));
        if(strstr(gw, ":") != NULL) return NOHAYPASARELA;
        if(strlen(gw) < 7) return NOHAYPASARELA;
        return strdup(gw);
     }
  else
     {
        return NOHAYPASARELA;
     }
   

}

const char *obtenermaclocal(const char *interfacered)
{
   char cmd[80] = {'\0'}, bufer[512] = {'\0'}, mac[80] = {'\0'};
   int i = 0;
   FILE *tub = NULL;

   if(interfacered == NOHAYMAC) return NOHAYMAC;
   strcpy(cmd, "ip link show ");
   strcat(cmd, interfacered);

   tub = popen(cmd, "r");
   if(tub == NULL) return NOHAYMAC;

   while(!feof(tub))
   {
    bufer[i] = fgetc(tub);
    if(i >= 511) return NOHAYMAC;
    if(bufer[i] == '\0') return NOHAYMAC;
    if(bufer[i] == EOF) bufer[i] = '\0';
    ++i;
   }
   pclose(tub);

  if(strcmp(bufer, "") == 0) return NOHAYMAC;
  if(strcpy(mac, strstr(bufer, "link/ether")) != NULL)
     {
        strcpy(mac, strstr(mac, " "));
        strcpy(mac, strtok(mac, " "));
        if(strstr(mac, ":") == NULL) return NOHAYMAC;
        if(strlen(mac) < 17) return NOHAYMAC;
        return strdup(mac);
     }
  else
     {
        return NOHAYMAC;
     }
}

short int darping(const char *host, unsigned int cantidad, unsigned int seg)
{
   char cmd[200] = {'\0'};
   char buf[200] = {'\0'};

   if(cantidad == 0 || seg == 0) return PINGINTERRUMPIDO;

   gcvt(cantidad, 4, buf);
  
   strcpy(cmd, "ping ");
   strcat(cmd, " -c ");
   strcat(cmd, buf);
   strcat(cmd, " ");
   strcat(cmd, host);
   strcat(cmd, " -i ");
   strcpy(buf, "");
   gcvt(seg, 4, buf);
   strcat(cmd, buf);
   return system(cmd);
}

unsigned short int verificainternet(const char *host)
{
   if(darping("google.com", 1, 2) == DIOPING)
      return HAYINTERNET;
   else
      return NOHAYINTERNET;
}

long int porcientodenum(float num, float maximo)
{
   return (num * 100.0) / maximo;
}

double alcubo(double x)
{
   return x * x * x;
}

double alcuadrado(double x)
{
   return x * x;
}

float resistlimcarga(float voltfuente, float voltcarga, float intenscarga)
{
  return voltenrdesdecarga(voltfuente, voltcarga) / intenscarga;
}

float voltenrdesdecarga(float voltfuente, float voltcarga)
{
   return voltfuente - voltcarga;
}

long int imprprimpotxsupy(long int x, long int y)
{
   long int prod;

   prod = x;

   while(prod <= y)
      prod *= 2;

   return prod;
}

unsigned short int asctocod(const char car)
{
  return (unsigned long int) car;
}

long int espar(long int num)
{
   if((num % 2) == 0)
      return 1;
   else
      return 0;
}

const char * obteneriplocal(const char *interfacered)
{
  char cmd[80] = {'\0'}, bufer[512] = {'\0'}, ip[80] = {'\0'};
  int i = 0;
  FILE *tub = NULL;

  if(interfacered == NOHAYIP) return NOHAYIP;
  strcpy(cmd, "ip addr show dev ");
  strcat(cmd, interfacered);

  tub = popen(cmd, "r");
  if(tub == NULL) return NOHAYIP;

  while(!feof(tub))
  {
    bufer[i] = fgetc(tub);
    if(i >= 511) return NOHAYIP;
    if(bufer[i] == '\0') return NOHAYIP;
    if(bufer[i] == EOF) bufer[i] = '\0';
    ++i;
  }
  pclose(tub);

  if(bufer[0] == '\0') return NOHAYIP;
  if(bufer[0] == ' ') return NOHAYIP;
  if(strlen(bufer) <= 7) return NOHAYIP;
  if(strcmp(bufer, "") == 0) return NOHAYIP;
  if(strstr(bufer, "inet") == 0) return NOHAYIP;
  if(strstr(bufer, "state DOWN") != NULL) return NOHAYIP;
  if(strcpy(ip, strstr(bufer, "inet")) != NULL)
     {
        strcpy(ip, strstr(ip, " "));
        strcpy(ip, strtok(ip, " "));
        strcpy(ip, strtok(ip, "/"));
        if(strstr(ip, ":") != NULL) return NOHAYIP;
        if(strlen(ip) < 7) return NOHAYIP;
        return strdup(ip);
     }
  else
     {
        return NOHAYIP;
     }
}

int ejecutarcomremotssh(const char *comando, const char *usuario, const char *ipremota)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "ssh ");
  strcat(cmd, usuario);
  strcat(cmd, "@");
  strcat(cmd, ipremota);
  strcat(cmd, " '");
  strcat(cmd, comando);
  strcat(cmd, "'");
  return system(cmd);
}

int matarproceso(const char *nombreproceso)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "pkill ");
  strcat(cmd, nombreproceso);
  return system(cmd);
}

void iniciarservicio(const char *servicio)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "systemctl start ");
  strcat(cmd, servicio);
  system(cmd);

  strcpy(cmd, "service ");
  strcat(cmd, servicio);
  strcat(cmd, " start");
  system(cmd);
}

void pararservicio(const char *servicio)
{
  char cmd[80] = {'\0'};
  strcpy(cmd, "systemctl stop ");
  strcat(cmd, servicio);
  system(cmd);

  strcpy(cmd, "service ");
  strcat(cmd, servicio);
  strcat(cmd, " stop");
  system(cmd);
}

float calculatiempomru(float distancia, float velocidad)
{
  return (distancia / velocidad);
}

float calculavelmru(float distancia, float tiempo)
{
  return (distancia / tiempo);
}

float calculadistmru(float velocidad, float tiempo)
{
  return (velocidad * tiempo);
}

void imprimirtablagradosfc(int limitebajo, int limitealto, int incremento)
{
   float fahr = 0, celsius = 0;

   printf("%s\t%s\n\n", "Fahr", "C");
   fahr = limitebajo;
   while(fahr <= limitealto)
   {
      celsius = 5.0 * (fahr - 32.0) / 9.0;
      printf("%3.0f\t%6.1f\n", fahr, celsius);
      fahr = fahr + incremento;
   }

}

float conviertefahrcelsius(float tempf)
{
   return (5.0 * (tempf - 32.0) / 9.0);
}

#endif
